/* RWhois Software 

Copyright (c) 1994 Scott Williamson and Mark Kosters

Users may distribute the binary and source code to third parties provided
that the copyright notice and this statement appears on all copies and that
no charge is made for such copies.  

This software is provided AS IS with no warranties of any kind.  The authors
shall have no liability with respect to the infringement of copyrights,
trade secrets or any patents by this file or any part thereof.  In no
event will the authors be liable for any lost revenue or profits or
other special, indirect and consequential damages.

Comments and additions should be sent to the authors:

                    Scott Williamson
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4820
					scottw@internic.net

                    Mark Kosters
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4795
					markk@internic.net

File: error.c  This is where it goes when an error response is recived. Some errors are not bad but mean that something more should be done.
Developed by: Scott Williamson

*/

#include "rwhois.h"
#include "error.h"


error_response( line)
char * line;
{
char *err_snum, *err_txt;
int ret;
struct SERVER *err_server;
char txtbuff[MAXBUFF];

				ret = WAIT_ERROR;

				err_snum = index( line, ' ');
				*(err_snum++) = NullCH;
				err_txt = index( err_snum, ' ');
				*(err_txt++) = NullCH;
				if( err_txt[strlen(err_txt)] == '\n' )
					err_txt[strlen(err_txt)] = NullCH;

				err_num = atoi( err_snum);

				err_server = SERVERCURRGET;

				switch( err_num)
				{

	/* EXCEEDED_MAXREC 330  Exceeded Max Records Limit */
					case  EXCEEDED_MAXREC:
						if((control_pannel[CP_LIMIT] & SET_WAIT) && !forcing )
							send_limit( 0, LIMIT_RESEND);
						else
							error("Limit request exceeds max records allowed by server");
						break;

	/* INVALID_MAXREC 331  Invalid Max Records Size */
					case	INVALID_MAXREC:
						if( control_pannel[CP_LIMIT] & SET_WAIT)
							send_limit( 20, LIMIT_SET);
						if( verbose > TALK | forcing )
					error("Problem with limit request setting to 20");
						break;

	/* UNRECOV_ERROR 502  Unrecoverable Error... Goodbye */
					case UNRECOV_ERROR:
	/* MEMORY_ALLOCATION_PROBLEM 500  Memory Allocation Problem */
					case MEMORY_ALLOCATION_PROBLEM:
	error("Unrecoverable server error has occurred ... must exit NOW!");
						ret = BAD;
						break;

	/* SERVICE_NOT_AVAIL 501  Service Not Available */
					case SERVICE_NOT_AVAIL:
message("Service not available at this server .. will try next server or exit");
							stop_flags();
							list_defaults();
							ret = WAIT_CONTINUE;
						break;

	/* FAILED_PEERNAME 100  Get Peer Name Query Failed */
					case  FAILED_PEERNAME:
						break;
	/* NO_RECORDS_FOUND 230  No Records Found */
					case  NO_RECORDS_FOUND:
						if( control_pannel[CP_DIRECTIVE]&SET_WAIT)
						{
							sprintf(txtbuff, "%s directive not avaiable on %s",
								directive_name, err_server->server);
							error( txtbuff);
						}
						else if( control_pannel[CP_SOA] & SET_WAIT
							|| authority )
						{
							if( verbose > WHISPER || forcing 
								|| control_pannel[CP_SOA]&SET_ALWAYS)
		note("Server not authority for area .. Answer not Authoritative");
							control_pannel[CP_SOA] = 
								(control_pannel[CP_SOA]&~SET_WAIT);
						}
						else if( edit )
						{
							note("No record to edit");
							if( goodedit == REG_DEL)
							{
			error("Can not delete something this is not there... sorry");
								ret = BAD;
							}
							else
							{
								goodedit = REG_NONE;
								question("Do you want a template");
								if(getchar() == 'y' )
									ret = WAIT_EDIT;
								else
									edit = FALSE;
							}
						}
						else
						{
							sprintf(txtbuff, "No records found for query: [%s]",
								err_server->query 
						 		? err_server->query 
						 		: "" );
							error( txtbuff);
							ret = BAD;
						}
						break;

	/* UNCOMPAT_VERSION 300  Not Compatible With That Version Number */
					/* client version incompatible with server */
					case  UNCOMPAT_VERSION:
						if( verbose > WHISPER )
						error("Client and server version incompatible");
							break;

	/* INVALID_DIRECTIVE 400  Invalid Server Directive */
					case INVALID_DIRECTIVE:
						if( verbose > WHISPER | forcing )
							error("Invalid directive sent to server");
							break;
	/* UNAUTH_DIRECTIVE 401  Not Authorized for Directive */
					case UNAUTH_DIRECTIVE:
						if( verbose > WHISPER | forcing )
							error("Directive not authorized for this user/host contact the server admin..");
							break;

	/* NO_SOA 333  Not SOA for Requested Authority Area */
					case  NO_SOA:
						if( control_pannel[CP_SOA] & SET_WAIT || authority )
						{
							if( verbose > WHISPER | forcing 
								| control_pannel[CP_SOA]&SET_ALWAYS)
			note("Server not authority for area .. Answer not Authoritative");
							control_pannel[CP_SOA] = 
								(control_pannel[CP_SOA]&~SET_WAIT);
						}
						break;

	/* NO_OBJECT_FOUND 336  Object Not Found */
					case NO_OBJECT_FOUND:
						/* This is to handle old servers ... right Mark */
						if((control_pannel[CP_DISPLAY] & SET_WAIT) 
							&& ( verbose > WHISPER ))
						{
							note("Display mode not accepted.. will continue");
							control_pannel[CP_DISPLAY] = 
								(control_pannel[CP_DISPLAY]&~SET_WAIT);
						}
						ret = WAIT_CONTINUE;	
						break;

	/* REFERRED_SERVICE 200  Service Not Available.. Referral To Follow */
					case REFERRED_SERVICE:
							stop_flags();
							ret = WAIT_CONTINUE;
						break;

/*INVALID_DIRECTIVE_PARAM 338  Invalid Directive Parameter */ 
					case INVALID_DIRECTIVE_PARAM:
						error("Invalid Directive Param");
						break;

					default:

printf("[%s]", line);
						sprintf(txtbuff, "Unknow error: <%d [%s]>" ,
							err_num, err_txt);
						error( txtbuff);
						break;
				}

	fflush(stdout);

	return( ret);
}

/* REGIST_DEFFERED 120  Registration Not Processed... Will Process Hours: */
/* NON_AUTH_ANSWER 130  Not Authority to Answer... TTL Good*/
/* NON_AUTH_MARTIAN 231  Not Authority to Answer.. TTL Expired */
/* UNAUTH_TO_CACHE  232  Cache Disabled */
/* INVALID_ATTRIBUTE 320  Invalid Attribute Line: */
/* INVALID_FORMAT 321  Invalid Format Line: */
/* MISSING_REQ_ATTRIB 322  Required Attribute Missing Name: */
/* MISSING_REL_OBJECT 323  Required Related Object Missing Name: */
/* NON_UNIQ_KEY 324  Primary Key Not Unique */
/* NO_TRANSFER 332  Nothing To Transfer */
/* UNIMPLEM_DIRECTIVE 334  Pre-query Directive Not Implemented */
/* UNAVAIL_SYSLOAD 335  Systems Load Not Available */
/* NO_OBJECT_SCHEMA_FOUND 337  No Format Found for Object */
/* UNIDENT_ERROR 402  Unidentified Error .. Continue */
/* UNAUTH_REGIST 420  Registration Not Authorized */
/* UNAUTH_REGIST_RECORD 421  Not Authorized to Change Object */
/* UNAUTH_TO_FRWD 431  Not Authorized To Forward */
/* UNAUTH_TO_XFER 432  Not Authorized To Transfer */
/* BAD_REF_ON_FRWD 433  Bad Reference On Forward */
/* NON_EXIST_REFER 434  Referral Does Not Exist on this Server */
/* UNDEF_DEFINE 435  Macro not Defined */
/* UNAUTH_DISPLAY 436  Display Mode Not Allowed */
/* UNSUPPORT_LANG 437  Language Not Supported */
/* UNKNOWN_X_DIRECTIVE 460  Extended Directive Not Recognized */
/* UNAUTH_X_DIRECTIVE 461  Extended Directive Not Authorized */
/* DEADMAN_TIME 503  Idle Time Exceeded... Goodbye */
/* UNAUTH_SECONDARY 530  Not Authorized As Secondary */
/* MISC_DIAG 560   */
