/* RWhois Software 

Copyright (c) 1994 Scott Williamson and Mark Kosters

Users may distribute the binary and source code to third parties provided
that the copyright notice and this statement appears on all copies and that
no charge is made for such copies.  

This software is provided AS IS with no warranties of any kind.  The authors
shall have no liability with respect to the infringement of copyrights,
trade secrets or any patents by this file or any part thereof.  In no
event will the authors be liable for any lost revenue or profits or
other special, indirect and consequential damages.

Comments and additions should be sent to the authors:

                    Scott Williamson
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4820
                    scottw@internic.net

                    Mark Kosters
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4795
                    markk@internic.net

File: preresp.c  The first pass of server responses. postresp.c is the other half.
Developed by: Scott Williamson

*/
#include "rwhois.h"
#include "errlist.h"

struct STATUS curr_server_status;

#ifndef atof
double atof();
#endif

pre_response( retline)
char *retline;
{
char altcmdline[80];
char refhost[80];
char *ptr;
char *hold_referral;
float load_current, load_average;
char attrib[80], avalue[80];
char *object_value, *type_value, *value;
int saport, satype;
struct SERVER *resp_server;
char temp[MAXBUFF];
int ret = WAIT_NULL;
struct SERVER samp_server; /* used to compare trail to current ref */
static char last_object[80];
char messbuff[MAXBUFF];
static FILE *holdfp;

                        /* not all runtime libraries initialize to zero */
                        bzero ((void *)&samp_server,sizeof(struct SERVER));
            
                        resp_server = SERVERCURRGET;


            if(!strncmp( retline, "%error", 6))
                ret = error_response( retline);



/* Start %ok */
            if( !strncmp( retline, "%ok", 3))
            {

                ret = WAIT_OK;

/* Check to see if waiting for response from directive */

    /*query*/   
                if( (control_pannel[CP_QUERY]&SET_WAIT) )
                {
                    control_pannel[CP_QUERY] = 
                        (control_pannel[CP_QUERY]&~SET_WAIT);

                    SERVERANSTIME;

                    /* check for registration processing */
                    regcheck(  resp_server);

                    if( verbose > TALK)
                        printf("\nAnswer took %s\n", 
                            showtime( resp_server->con_time, 
                                resp_server->ans_time));


                }
    /*prompt */
                else if( control_pannel[CP_PROMPT] & SET_WAIT )
                {
                    control_pannel[CP_PROMPT] = 
                        (control_pannel[CP_PROMPT]&~SET_WAIT);
                    ret = WAIT_IDYES;
                }   
    /* load */
                else if( control_pannel[CP_LOAD] & SET_WAIT )
                    control_pannel[CP_LOAD] = 
                        (control_pannel[CP_LOAD]&~SET_WAIT);
    /* holdconnect */
                else if( control_pannel[CP_HOLDCONNECT] & SET_WAIT )
                {
                    control_pannel[CP_HOLDCONNECT] = 
                        (control_pannel[CP_HOLDCONNECT]&~SET_WAIT);
                    if( verbose > WHISPER )
                        printf("\nholdconnect is %s\n", 
                            default_holdconnect ? "ON" : "OFF");
                }
    /*limit*/
                else if( control_pannel[CP_LIMIT] & SET_WAIT)
                {
                    if( verbose > WHISPER)
                        printf("\nLimit set to %d", 
                            send_limit( 0, LIMIT_CURRENT));
                    control_pannel[CP_LIMIT] = 
                        (control_pannel[CP_LIMIT]&~SET_WAIT);
                }
    /*precmd*/
                else if( control_pannel[CP_PRECMD] & SET_WAIT)
                {
                    if( verbose > TALK )
                        printf("\nClearing the pre-cmd send");
                    control_pannel[CP_PRECMD] = 
                        (control_pannel[CP_PRECMD]&~SET_WAIT);
                }
    /*cache*/
                else if( control_pannel[CP_CACHE] & SET_WAIT)
                {
                    if( verbose > WHISPER )
                    printf("\nCache now %s\n", default_cache ? "ON" : "OFF");
                    control_pannel[CP_CACHE] = 
                        (control_pannel[CP_CACHE]&~SET_WAIT);
                }

    /*display*/
                else if( control_pannel[CP_DISPLAY] & SET_WAIT)
                {
                    if( verbose > WHISPER )
                    printf("\nDisplay mode set");
                    control_pannel[CP_DISPLAY] = 
                        (control_pannel[CP_DISPLAY]&~SET_WAIT);
                }
    /*soa*/
                else if( control_pannel[CP_SOA] & SET_WAIT)
                {
                    if( verbose > WHISPER || authority )
                    {
                        sprintf(messbuff, "Authoritative answer for %s", 
                                autharea ? autharea : resp_server->query);
                        message( messbuff);
                    }
                    control_pannel[CP_SOA] = 
                        (control_pannel[CP_SOA]&~SET_WAIT);
                }

    /*xfer*/
                else if( control_pannel[CP_XFER] & SET_WAIT)
                {
                    if( verbose > WHISPER | forcing)
                    printf("\nTransfer complete for %s object\n",   
                                xfer_object);
                    putchar( '\n');
                    control_pannel[CP_XFER] = 
                        (control_pannel[CP_XFER]&~SET_WAIT);
                }

    /*schema*/
                else if( control_pannel[CP_SCHEMA] & SET_WAIT)
                {
                    if( verbose > WHISPER )
                        printf("\nSchma dump complete\n");
                    putchar('\n');
                    control_pannel[CP_SCHEMA] = 
                        (control_pannel[CP_SCHEMA]&~SET_WAIT);

                /*  regcheck( resp_server); */

                    /* if in the edit mode must be geting the template */
                    if( to_file && edit == ON && goodedit == REG_ADD)
                    {
                        to_file = FALSE;

                        closefile( resp_server);

                        if( editpath)
                        {
                    sprintf( temp, "%s %s", editpath, resp_server->filename);
                            system( temp);
                        }
                        else
                            printf("\nEditor not defined must quit");

                    }
                    ret = WAIT_EDIT;
                }

    /* object */
                else if( control_pannel[CP_OBJECT] & SET_WAIT)
                {
                    if( verbose > WHISPER )
                        printf("\nObject list complete\n");
                    putchar('\n');
                    control_pannel[CP_OBJECT] = 
                        (control_pannel[CP_OBJECT]&~SET_WAIT);
                }


    /*directive*/
                else if( control_pannel[CP_DIRECTIVE] & SET_WAIT)
                {
                    if( verbose > WHISPER | forcing )
                        if( directive_name )
                            printf("\n%s directive does exist", directive_name);
                        else
                            printf("\nEnd of directives for this server\n");
                    putchar('\n');
                    control_pannel[CP_DIRECTIVE] = 
                        (control_pannel[CP_DIRECTIVE]&~SET_WAIT);
                }

    /* status */
                else if( control_pannel[CP_STATUS] & SET_WAIT)
                {
                    if( verbose > WHISPER )
                        printf("\nStatus check complete:\n");
                    
                    if( upd_status( resp_server->server_id, 
                        &curr_server_status))
                        printf("\nUnable to update server struct status");
                    if((verbose > TALK | forcing))
                        prt_server_status();
                    control_pannel[CP_STATUS] = 
                        (control_pannel[CP_STATUS]&~SET_WAIT);
                }

    /* register */
                else if( control_pannel[CP_REGISTER]&SET_WAIT)
                {

                    if(control_pannel[CP_REGISTER]&SET_ON)
                    {
                        if( reg_only)
                            data_register( regfile);
                        else    
                            data_register( resp_server->filename);
                        control_pannel[CP_REGISTER] = 
                            ((control_pannel[CP_REGISTER]&~(SET_SEND&SET_ON))
                                |(SET_WAIT&SET_OFF));
                    }
                    else if( control_pannel[CP_REGISTER] & SET_OFF)
                    {

                        note("Registration complete");

                        control_pannel[CP_REGISTER] = 
                            (control_pannel[CP_REGISTER]&~(SET_WAIT&SET_OFF));
                    }
                }


    /* referrals finished */
                else if( control_pannel[CP_REFERRAL] & SET_WAIT)
                {
                    ret = WAIT_REFERRAL;
                    control_pannel[CP_REFERRAL] = 
                        (control_pannel[CP_REFERRAL]&~SET_WAIT);
                }

    /* see-also finished */
                else if( control_pannel[CP_SEEALSO] & SET_WAIT)
                {
                    ret = WAIT_SEEALSO;
                    control_pannel[CP_SEEALSO] = 
                        (control_pannel[CP_SEEALSO]&~SET_WAIT);
                }



            }
/* End %ok */



/* Start %referral  */
            if((sscanf( retline, "%%referral %s", refhost)))
            {

            /* defalut referrance type */
            samp_server.reftype = REF_REFERRAL;

            /* grab the authority area is on exists ... save for soa check */
            if( ptr = index( retline, ' '))
                if( ptr = index( ++ptr, ' '))
            {
                ++ptr;
                trimstr( ptr);

                if(strlen( ptr))
                {
                    autharea = safecalloc( 1, strlen( ptr)+1);
                    strcpy( autharea, ptr);
                }
                else
                {
                    autharea = NULL;
                    samp_server.reftype = REF_PUNT;
                    /* temp fix for server that does not do %ok after punt */
                    punt_referral = TRUE;
                }


                if( verbose > TALK )
                    printf("\nReceived authority area [%s] on referral",
                        autharea);
            }
            else
            {
                samp_server.reftype = REF_PUNT;
                /* temp fix for server that does not do %ok after punt */
                punt_referral = TRUE;
            }

            /* end of authority area grab */

            if( extreferral == FALSE )
            {
                referral = 0;
                SERVERERASE;
            }

            hold_referral = safecalloc( 1, (strlen( resp_server->server ) + 15));
                sprintf( hold_referral, "%s:%d", resp_server->server, 
                    resp_server->port);

#ifdef DEBUG
printf("\ngot referal [%s] -- [%s]\n", refhost, hold_referral);
fflush(stdout);
#endif
            if( verbose > WHISPER )
                printf("\n[%d]-Received referral to %s\n",
                    referral+1, refhost);

            extreferral = TRUE; 
            control_pannel[CP_QUERY] = (control_pannel[CP_QUERY]&~SET_WAIT);
            control_pannel[CP_REFERRAL] = SET_WAIT;
#ifdef DEBUG
printf("\ngoing to fix_server with [%s] [%s]\n", refhost, hold_referral);
fflush(stdout);
#endif
            brk_server( refhost, &saport, &satype);

#ifdef DEBUG
printf("\n[%s] %d %d", refhost, saport, satype);
fflush(stdout);
#endif

            samp_server.port = saport;
            samp_server.type_status = satype;
            samp_server.server = safecalloc( 1, strlen( refhost)+1);
            strcpy( samp_server.server, refhost);
            samp_server.referral = safecalloc( 1, strlen(hold_referral)+1);
            strcpy( samp_server.referral, hold_referral);

            samp_server.query = safecalloc( 1, strlen(resp_server->query)+1);
            strcpy( samp_server.query, resp_server->query);
            if(!server_main( SER_COMPARE, &samp_server))
            {
                free(samp_server.query);
                samp_server.query = resp_server->query;
                server_main( SER_ADD, &samp_server);
            }
            else {
              free(samp_server.query);
              if( verbose > WHISPER)
                error("Received repeat referral not adding");
            }

            free(samp_server.referral);
            free(samp_server.server);

        }
/* End %referral */

/* Start %see-also */
            else if(!strncmp( retline, "%see-also", 9 ))
            {

                if(ptr = index( retline, ' '))
                {
                    fprintf(  resp_server->fp, "%s\n", retline);
                    fflush(resp_server->fp);

                    if(strncmp( ++ptr, "url", 3))
                    {

                    /* grab the new query ( it is required ) */
                        ptr = rindex( retline, ':');
                        *(ptr++) = NullCH;

                        strcpy( altcmdline, ptr);

                    /* make sure that line is not term with return */
                        if((ptr = index( altcmdline, '\n')))
                            *ptr = NullCH;

                        ptr = index( retline, ' ');
                        strcpy( refhost, ++ptr);

                        ++extsee_also;

#ifdef DEBUG
printf("\ngot see-also [%s] with query [%s]\n", refhost, altcmdline);
fflush(stdout);
#endif

                        if( verbose > WHISPER )
                        {
                        printf("\n[%d]-Received see-also to %s with query %s ",
                                referral+1, refhost, altcmdline);
                        }
    
                        brk_server( refhost, &saport, &satype);
                        samp_server.server = refhost;
                        samp_server.port = saport;
                        samp_server.type_status = satype;
                        samp_server.reftype = REF_SEEALSO;
                        samp_server.query = altcmdline;
                        server_main( SER_INSERT,  &samp_server);

                        control_pannel[CP_QUERY] = 
                            (control_pannel[CP_QUERY]&~SET_WAIT);
                        control_pannel[CP_SEEALSO] = SET_WAIT;

                    }
                }
            }
/* End %see-also */

/* Start %load */
            if(!strncmp( retline, "%load", 5))
            {
                sscanf( retline, "%%load %f %f", &load_current, &load_average);

            if( verbose > WHISPER || forcing )
                printf("\n%s's load is currently %f with an average of %f\n", 
                    resp_server->server, load_current, load_average);

            }

/* Start %soa */
            if(!strncmp( retline, "%soa", 4))
            {
                if( verbose > TALK | forcing )
                {
                    sscanf( retline, "%%soa %s %s", attrib, avalue);
                    printf("\nSOA - %s = %s", 
                        attrib, avalue);
                }
            }

/* Start %status */
            if(!strncmp( retline, "%status", 7))
            {
                procstatus( retline);
            }


/* Start %schema */

            if(!strncmp( retline, "%schema", 7))
            {
                if(((verbose > TALK | forcing) | edit == ON ) 
                    && (index( retline, ':')))
                {

                    if(!brkresponse( 3, retline, &object_value, &type_value, 
                        &value))
                    {

                        if(strncmp( object_value, last_object, 
                            strlen( object_value)))
                        {
                            strncpy( last_object, object_value, 
                                strlen( object_value));
                            last_object[strlen(object_value)] = NullCH;
        /*                  sprintf( temp, "\nSchema:%s\n", last_object);
                            if( to_file)
                                wkfile_write( resp_server, temp); 

                            else
                                puts(temp); */
                        }

                        upper( type_value);
                        if( to_file && !strncmp( type_value, "ATTRIBUTE", 9))
                        {

                            sprintf( temp, "%s:%s:\n", last_object, value);
                            wkfile_write( resp_server, temp);
                            goodedit = REG_ADD;

                        }
                        else if (!to_file) 
                        {
                            if(!strncmp( type_value, "ATTRIBUTE", 9))
                                printf("%s", value);
                            if(!strncmp( type_value, "FORMAT", 6))
                                printf(" [%s]", value);
                            if(!strncmp( type_value, "DESCRIPTION", 11))
                                printf(" - %s", value);
                        }
                    }
                }
            /*  else
                {
                    if( verbose > TALK || forcing  && edit != ON)
                        putchar( '\n');

                }   */
            }

/* Start directive */

            if(!strncmp( retline, "%directive", 10))
            {
                if((verbose > TALK ) | forcing )
                {

                    if(index( retline, ':'))
                    {
                        if(!brkresponse( 2, retline, &type_value, 
                            &value, &object_value))
                        {
                            if(!strncmp( type_value, "directive", 9))
                                printf("%s", value);
                            if(!strncmp( type_value, "description", 11))
                                printf(" (%s)", value);
                            if(!strncmp( type_value, "syntax", 6))
                                printf(" [%s]", value);
                        }
                    }
                    else
                        putchar( '\n');

                }
            }


/* Start %xfer */

            if(!strncmp( retline, "%xfer", 5))
            {
                if(!brkresponse( 3, retline, &object_value, &type_value, 
                    &value))
                {
                    sprintf( temp, "%s:%s:%s\n", 
                        object_value, type_value, value);
                    wkfile_write( resp_server, temp);
                }
                else
                    wkfile_write( resp_server, "------------------\n");
                

            }

/* object */

            if(!strncmp( retline, "%object", 7))
            {
                    if(!brkresponse( 3, retline, &object_value, &type_value, 
                        &value))
                    {
                        if(strcmp( object_value, last_object))
                        {
                                printf("\n%s", object_value);
                                strcpy( last_object, object_value);
                        }

                        if( edit != ON )
                            printf("\n%s:%s", type_value, value);
                    }
                    else if( edit != ON )
                        printf("\n------------------");
                

            }


/* display */

            if(!strncmp( retline, "%display", 7))
            {
                if(!brkresponse(2, retline, &type_value, &value, &object_value))
                {
                    printf("\nReceived Display type: %s\n", value);
                    upper( value);

                    if(!strcmp( value, "MIME"))
                    {
                        strcpy( temp, FILENAMEMASK);
                        mktemp( temp);
                        fprintf( resp_server->fp,"%%display activate:MIME:%s", 
                                temp);
                        /* move the open file pointer till diplay finished */
                        holdfp = resp_server->fp;

                        /* open new file for display output */
                        resp_server->fp = fopen( temp, "w");

                        mime = TRUE;
                    }
                /*   Not sure what to do with this  yet.
                    else if(!strcmp( value, "URL"))
                    {
                        fprintf( resp_server->fp,"%%display URL %s", 
                            temp);
                        url = TRUE;
                    } */
                    else 
                        error("Invalid dispay type");

                }
                else
                {
                    fclose( resp_server->fp);
                    resp_server->fp = holdfp;
                }
            }

/* info */
            if(!strncmp( retline, "%info", 5))
            {
                value = index( retline, ' ');

                if( value == NULL ) return( WAIT_ERROR);

                while( *value == ' ')
                    ++value;

                upper( value);

                if(!strncmp( value, "ON", 2))
                {
                    sprintf( temp, "From %s:\n", resp_server->server);
                    message( temp);
                    current_modes = (current_modes | MODE_INFO);
                }
                else
                    current_modes = (current_modes & ~MODE_INFO);
            }
/* end info */

    return(ret);
}



procstatus( line)
char *line;
{
struct SERVER *curr_server;
int bol_value;
char *object_value, *type_value, *value;


    curr_server = SERVERCURRGET;

#ifdef DEBUG
printf("\nStart [%s]", line);
#endif

    if(!brkresponse( 2, line, &type_value, 
        &value, &object_value))
    {
        upper( type_value);
        upper( value);

#ifdef DEBUG
printf("\nInside [%s]", value);
#endif

        if( !strcmp( value, "ON"))
            bol_value = ON;
        else if( !strcmp( value, "OFF"))
            bol_value = OFF;

        if(!strncmp( type_value, "LIMIT", 5))
            curr_server_status.limit = atoi( value);
        if(!strncmp( type_value, "LOAD", 4))
            curr_server_status.load = atof( value);
        if(!strncmp( type_value, "CACHE", 5))
            curr_server_status.cache = bol_value;
        if(!strncmp( type_value, "HOLDCONNECT", 11))
            curr_server->server_status.holdconnect = bol_value;
        if(!strncmp( type_value, "FORWARD", 7))
            curr_server_status.forward = bol_value;
        if(!strncmp( type_value, "AUTHORITY", 9))
            curr_server_status.authority = atoi( value);
        if(!strncmp( type_value, "RECORDS", 7))
            curr_server_status.authority = atoi( value);
        if(!strncmp( type_value, "CACHED", 6))
            curr_server_status.cached = atoi( value);
    }
}
