/************************************************************************
RWhois Software 

Copyright (c) 1994 Scott Williamson and Mark Kosters

Users may distribute the binary and source code to third parties provided
that the copyright notice and this statement appears on all copies and 
that no charge is made for such copies.  

This software is provided AS IS with no warranties of any kind.  The authors
shall have no liability with respect to the infringement of copyrights,
trade secrets or any patents by this file or any part thereof.  In no
event will the authors be liable for any lost revenue or profits or
other special, indirect and consequential damages.

Comments and additions should be sent to the authors:

                    Scott Williamson
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4820
                    scottw@internic.net

                    Mark Kosters
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4795
                    markk@internic.net


Developed By: 
  Mark Kosters
***************************************************************************/


#ifndef _OUTPUT_H_
#define _OUTPUT_H_

/* includes */

#include "common.h"
#include "types.h"

/* defines */

/* output format tokens */
#define O_TYPE         "type"
#define O_FIELD        "field"
#define O_FIXED_LEN    "fixed-len"
#define O_TITLE        "title"
#define O_DATA         "data"
#define O_MULTI_DELIM  "multi-delim"
#define O_SUB_FORMAT   "sub-format"
#define O_SUB_DEFER    "sub-defer"
#define O_SUB_DEREF    "sub-deref"
#define O_CONDIT_POS   "condit-pos"
#define O_CONDIT_NEG   "condit-neg"
#define O_FRMT_CONVRT  "format-convert"

#define O_FIELD_DEF     "field"
#define O_TEXT_DEF      "text"
#define O_CONDIT_TEXT   "condit-text"
#define O_AUTH_ELEM     "auth-elem"

/* prototypes */

output_format_struct *
encode_output_format PROTO((output_format_struct *format_list, char *file));

#endif /* _OUTPUT_H_ */
