/************************************************************************
RWhois Software 

Copyright (c) 1994 Scott Williamson and Mark Kosters

Users may distribute the binary and source code to third parties provided
that the copyright notice and this statement appears on all copies and 
that no charge is made for such copies.  

This software is provided AS IS with no warranties of any kind.  The authors
shall have no liability with respect to the infringement of copyrights,
trade secrets or any patents by this file or any part thereof.  In no
event will the authors be liable for any lost revenue or profits or
other special, indirect and consequential damages.

Comments and additions should be sent to the authors:

                    Scott Williamson
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4820
                    scottw@internic.net

                    Mark Kosters
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4795
                    markk@internic.net


Developed By: 
  Mark Kosters
***************************************************************************/

#ifndef _RECORDS_H_
#define _RECORDS_H_

/* includes */

#include "common.h"
#include "types.h"

/* prototypes */

record_struct *read_record_from_text PROTO((record_struct *top_record,
                                            char          *txt,
                                            int           (*sort_order)()));

field_struct *read_fields_from_text PROTO((char *txt));

field_struct *add_field PROTO((field_struct *fields, char *object_name,
                               char *attribute_name, char *datum));

void free_records PROTO((record_struct *records));

void free_fields PROTO((field_struct *fields));

#endif /* _RECORDS_H_ */
